@echo off
cls
REM ###################################################
REM Creates an rFactor installation in the current folder that is mostly a set
REM of junction points to a main installation elsewhere.  This new installation
REM only has a subset of vehicles and locations (see below) which
REM a) means rFactor loads quicker
REM b) leaves fewer to choose from in the rFactor menus
REM
REM See https://forum.studio-397.com/index.php?threads/rf2-multiple-installs-on-steam-tutorial.54092/page-3#post-1059009

echo rF2 mini install V0.1

setlocal

if exist YouWereWarned goto Proceed
echo FIRST RUN WARNING
echo.
echo 1. This works for me. I've tested it thoroughly but I offer no guarantees what will happen on other systems thougheverything it does is in the parent folder you specify to put things in
echo 2. It's just a batch file so it'sYou Asked For It You Got Itrather than WYSIWYG. If you're not familiar with the CMD window and editing files then it's probably not for you.
echo.
echo Usage:
echo 1. Create a new folder and unzip the file in there.
echo 2. Make a copy of Sample.modfile.txt and edit the paths at the top of the file
echo 	1. to suit where you have rFactor installed on your system (note that I have the Steam workshop set up on a HD to save SSD space)
echo 	2. to pick the vehicles and locations you want
echo    3. to specify the parent folder where your mini install will go
echo    4. the install_name which is used as a subfolder of parent_folder: the mini install will be in parent_folder\install_name
echo 3. Run this file with the modfile.txt e.g. 
echo    rF2_miniInstall.bat Sample.modfile.txt 
echo    (you can also drop Sample.modfile.txt on to rF2_miniInstall.bat in Windows Explorer)
echo    It only takes a few seconds to set up. If Steam pops up "Allow game launch?"  cancel it then switch back to the command window, Ctrl/C rF2_miniInstall.bat and run it again
echo 4. It leaves the junction points so you can just run it again.
echo 5. Or create another copy of the modfile.txt, change install_name and it will copy into there
echo 6. Anytime you want just delete the folder, it won't affect your main rFactor install 

choice /c PQ /M "Proceed or quit?"
if errorlevel 2 goto :pauseExit

echo. > YouWereWarned

:Proceed
rem Default path, can be overridden in mod file
rem rf2dir=[path to rF2 install]
set rf2dir=%ProgramFiles(x86)%\Steam\steamapps\common\rFactor 2
set workshop=k:\SteamOffSSD\workshop
set replays=k:\SteamOffSSD\common\rFactor 2\UserData\Replays
set process=rfactor2.exe
set game=rFactor 2
set SteamCmd=%ProgramFiles(x86)%/Steam/steam.exe
set modfile=%~dpnx1
if '%modfile%' == '' goto helpNoModfile
if not exist %modfile% goto helpNoModfile
echo Using %modfile%
set verbose=0
set dryrun=0
set parent_folder=%rf2dir%\UserData\parent_folder
rem Parse the modfile
for /f "eol=# tokens=1,2* delims==" %%i in (%modfile%) do (
 if /i '%%i' == 'install_name' set install_name=%%j
 if /i '%%i' == 'rf2dir' set rf2dir=%%j
 if /i '%%i' == 'workshop' set workshop=%%j
 if /i '%%i' == 'replays' set replays=%%j
 if /i '%%i' == 'SteamCmd' set SteamCmd=%%j
 if /i '%%i' == 'parent_folder' set parent_folder=%%j
 if /i '%%i' == 'verbose' set verbose=%%j
 if /i '%%i' == 'dryrun' set dryrun=%%j
 )
if %verbose% GTR 0 echo Full path: %modfile%

if '%install_name%' == '' goto helpNoName

:::::::::::::::::::::::::::::::::::::::::::::::::
rem OK, ready to go
echo install_name: %install_name%
echo rf2dir: %rf2dir%
echo parent_folder: %parent_folder%
if %verbose% GTR 0 echo verbose: %verbose%
if %dryrun% GTR 0 echo dryrun ON
if %verbose% GTR 2 echo on
echo.

rem Create a folder for the mod
pushd "%rf2dir%"
if errorlevel 1 goto no_rf2dir
md "%parent_folder%\%install_name%"
if not exist "%parent_folder%\%install_name%" goto parent_folder_error
pushd "%parent_folder%\%install_name%"
if errorlevel 1 goto parent_folder_error
set _modfolder=%cd%
if %verbose% GTR 1 ( 
  echo parent_folder: "%parent_folder%"
  echo install_name: "%install_name%"
  echo _modfolder: "%_modfolder%"
  )
echo Creating rFactor copy in %_modfolder%
echo.

:::::::::::::::::::::::::::::::::::::::::::::::::
if not exist installed md installed

rem Symlinks (actually "Junctions" which do not require admin rights)
rem back to the main install
for %%d in (Bin
Bin32
Bin64
Core
Launcher
LOG
Manifests
ModDev
PluginData
steam_shader_cache
Support
Templates
Updates
_CommonRedist 
installed\Commentary
installed\HUD
installed\Nations
installed\rFm
installed\Showroom
installed\Sounds
installed\Talent
installed\UIData
) do if %verbose%==0 (
  if not exist %%d mklink /j "%%d" "%rf2dir%\%%d" > nul
  ) else (
  if not exist %%d mklink /j "%%d" "%rf2dir%\%%d"
  )

if not exist "%rf2dir%"   echo Directory '%rf2dir%' not found   & goto failed
if not exist "%workshop%" echo Directory '%workshop%' not found & goto failed
if not exist "%replays%"  echo Directory '%replays%' not found  & goto failed

if not exist *.dll copy "%rf2dir%\*.dll" & echo 365960 > steam_appid.txt
if not exist UserData        md UserData        && copy "%rf2dir%\UserData\*.*" UserData 
if not exist UserData\player md UserData\player && copy "%rf2dir%\UserData\Player\*.json" UserData\Player

if not exist steamapps\workshop mkdir steamapps & mklink /j steamapps\workshop "%workshop%"
if not exist UserData\Replays   mklink /j UserData\Replays   "%replays%"

REM Pace car
for %%d in (CorvettePC, CorvettePCLights) do call :install Vehicles %%d
:::::::::::::::::::::::::::::::::::::::::::::::::
rem Symlinks to selected Locations & Vehicles

rem Parse the modfile for Locations
for /f "eol=# tokens=1,2* delims==" %%i in (%modfile%) do if /i '%%i' == 'Location' call :install Locations %%j

:::::::::::::::::::::::::::::::::::::::::::::::::

rem Parse the modfile for Vehicles
for /f "eol=# tokens=1,2* delims==" %%i in (%modfile%) do if /i '%%i' == 'Vehicle' call :install Vehicles %%j

:::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::
rem Check if Steam running
Set "MyProcess=Steam.exe"
tasklist /NH /FI "imagename eq %MyProcess%" 2>nul |find /i "%MyProcess%">nul
if not errorlevel 1 (
  Echo "%MyProcess%" is running
  goto :SteamRunning )

rem start it if not
echo Starting "%MyProcess%"
start "" /min "%SteamCmd%"
Set "MySubProcess=SteamService.exe"
:loop
  timeout 1 > nul
  tasklist /NH /FI "imagename eq %MySubProcess%" 2>nul |find /i "%MySubProcess%">nul
  if errorlevel 1 goto loop
echo Steam takes some time to get going, allowing it to load...
timeout 15
echo "%MyProcess%" running

:SteamRunning
:::::::::::::::::::::::::::::::::::::::::::::::::

popd
echo.
@echo Starting rFactor 2 singleplayer...

if %dryrun%==0 (
start Bin64\rFactor2.exe  +singleplayer +path="%parent_folder%\%install_name%" +trace=2

call :wait
rem Unload Logitech Profiler if it's running
taskkill /IM "LWEMon.exe" /F 2> nul
  ) else (
  echo      DRY RUN.  rFactor has now exited
  pause
  )


echo.
if %verbose% == 0 goto :pauseExit
  set /p _delete=Enter K if you want to KEEP the temporary rFactor copy "%install_name%":
  if /I '%_delete%' == 'k' goto :pauseExit

:deleteCopy
rmdir /s /q "%_modfolder%"
rem Delete the parent_folder folder if there was nothing else in it.
rmdir %parent_folder% > nul 2>&1
echo %_modfolder% deleted.

if '%2' == 'ModManager.exe' Exit
goto :pauseExit

:::::::::::::::::::::::::::::::::::::::::::::::::
:install
  if not exist installed\%1 md installed\%1
  if exist "%rf2dir%\Installed\%1\%2" (
    if %verbose% GTR 1 (
      if not exist installed\%1\%2 mklink /j installed\%1\%2 "%rf2dir%\installed\%1\%2"
      ) else (
      if not exist installed\%1\%2 mklink /j installed\%1\%2 "%rf2dir%\installed\%1\%2"> nul
      echo Added %1 %2
      )
    ) else echo "%rf2dir%\installed\%1\%2" not found

goto :eof

:::::::::::::::::::::::::::::::::::::::::::::::::
:wait
@echo Wait for %game% to start (%process%)...
timeout /t 2 > nul
:WaitStart
%SystemRoot%\System32\qprocess.exe %process% >nul 2>&1
if errorlevel 1 (
	timeout /t 2 > nul
	goto :WaitStart
	)
@echo %game% started
@echo Wait for %game% to close down...
:WaitStop
%SystemRoot%\System32\qprocess.exe %process% >nul 2>&1
if errorlevel 1 (
	echo %game% finished
	goto :eof
	) else (
	timeout /t 2 > nul
	goto :WaitStop
	)
goto :eof

:::::::::::::::::::::::::::::::::::::::::::::::::

:helpNoModfile
@echo off
echo Usage: %0 ^<Modfile^>
echo (or you can drop ^<Modfile^> on %0)
echo.

:helpNoName
@echo off
echo The Modfile must have
echo PARENT_FOLDER=^<path^> where to put the mini install
echo INSTALL_NAME=^<Name for the mod^> (preferably one word)
echo (the mini install will be created in PARENT_FOLDER\INSTALL_NAME)
echo LOCATION=^<Track folder name^>
echo repeat as required
echo VEHICLE=^<Vehicle folder name^>
echo repeat as required
echo.
echo For example
echo parent_folder=c:\games\rfactor2
echo install_name=1960s_F1_UK
echo Location=CRYSTAL PALACE 1969
echo Location=Silverstone90s
echo Location=BrandsHatch
echo etc.
echo Vehicle=Brabham_1966
echo Vehicle=Ferrari_312_67
echo Vehicle=Historic Challenge_EVE_1968
echo.
echo Anything on a line after # is a comment
echo.
echo If your rFactor is installed somewhere other than
echo %ProgramFiles(x86)%\Steam\steamapps\common\rFactor 2
echo then you can add a line like this
echo rf2dir=d:\games\Steam\steamapps\common\rFactor 2
echo.
echo Similarly for the command to start Steam
echo SteamCmd=%ProgramFiles(x86)%\Steam\Steam
echo.
echo Advanced options
echo verbose=0,1 or 2       for extra progress messages
echo dryrun=1               run %0 but don't start rFactor
echo.
pause
goto pauseExit

:parent_folder_error
echo.
echo ERROR
echo.
echo Could not create temp folder "%parent_folder%\%install_name%"
goto pauseExit


:failed
pause This is not set up correctly for your system
goto :eof

:no_rf2dir
echo.
echo ERROR
echo.
echo Could not find rFactor 2 folder "%rf2dir%"

:pauseExit
echo.
echo All done, press a key to quit
timeout /t 10 > nul



